//----------------------------------------------------------------------//
// FLAC̏														//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <memory>
#include "usr_str.h"
#include "usr_file_ex.h"
#include "usr_shell.h"
#include "usr_wic.h"
#include "usr_flac.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

//---------------------------------------------------------------------------
//FLACt@C̏擾
//---------------------------------------------------------------------------
bool FLAC_GetInf(
	UnicodeString fnam,		//t@C
	TStringList *lst,		//ʃXg(=e ̌`Ŋi[)	(default = NULL)
	int *len,				//[o] 								(default = NULL)
	bool id_min)			// O=l `Ŏ擾				(default = false)
{
	bool ret = false;
	try {
		if (!file_exists(fnam)) Abort();

		std::unique_ptr<TFileStream> fs(new TFileStream(fnam, fmOpenRead | fmShareDenyNone));
		BYTE xbuf[4];
		if (fs->Read(xbuf, 4)!=4) Abort();
		if (xbuf[0]!='f' || xbuf[1]!='L' || xbuf[2]!='a' || xbuf[3]!='C') Abort();

		for (;;) {
			if (fs->Read(xbuf, 1)!=1) Abort();
			bool last_blk = ((xbuf[0]&0x80)!=0);

			int dlen  = fsRead_int3(fs.get(), true);
			int nxt_p = fs->Seek(0, soFromCurrent) + dlen;
	
			switch (xbuf[0]) {
			case 0:	//STREAMINFO
				if (id_min) break;
				fs->Seek(10, soFromCurrent);
				if (fs->Read(xbuf, 4)==4) {
					//`
					unsigned int s_rate = ((xbuf[0]<<16) | (xbuf[1]<<8) | xbuf[2])>>4;
					unsigned int s_bit	= ((xbuf[2] & 0x01)<<4) + (xbuf[3]>>4) + 1;
					unsigned int chn	= ((xbuf[2]>>1) & 0x07) + 1;
					UnicodeString tmp;
					if (lst) {
						UnicodeString lbuf = get_PropTitle(_T("`")).cat_sprintf(_T("%uHz %ubit "), s_rate, s_bit);
						if (chn<=2)
							lbuf.cat_sprintf(_T("%s"), (chn==2)? _T("XeI") : _T("m"));
						else
							lbuf.cat_sprintf(_T("%uch"), chn);
						lst->Add(lbuf);
					}
					//
					unsigned __int64 total = (__int64)(xbuf[2] & 0x04)<<32;
					if (fs->Read(xbuf, 4)!=4) Abort();
					total += (unsigned int)((xbuf[0] << 24) | (xbuf[1] << 16) | (xbuf[2] << 8) | xbuf[3]);
					if (s_rate>0 && total>0) {
						unsigned int ms = total/s_rate*1000;
						if (lst) add_PropLine(_T(""), mSecToTStr(ms, false), lst);
						if (len) *len = ms;
					}
				} else Abort();
				break;

			case 4:	//VORBIS_COMMENT
				if (lst) {
					//Vendor
					UnicodeString lbuf = fsRead_comment_utf8(fs.get());
					if (!id_min && !lbuf.IsEmpty()) add_PropLine(_T("VENDOR"), lbuf, lst);
					//Comment
					int n = fsRead_int4(fs.get());
					for (int i=0; i<n; i++) {
						lbuf = fsRead_comment_utf8(fs.get());
						if (lbuf.Pos("=")) {
							if (id_min)
								lst->Add(lbuf);
							else
								add_PropLine(get_tkn(lbuf, "="), get_tkn_r(lbuf, "="), lst);
						}
					}
				}
				break;
			}

			if (last_blk) break;
			fs->Seek(nxt_p, soFromBeginning);
		}

		ret = true;
	}
	catch (...) {
		if (lst) lst->Clear();
	}
	return ret;
}

//---------------------------------------------------------------------------
//FLACt@C疄ߍ݉摜rbg}bvŎ擾 or t@Cɏo
//---------------------------------------------------------------------------
bool FLAC_GetImage(
	UnicodeString fnam,			//t@C
	Graphics::TBitmap *bmpimg,	//o̓rbg}bv	(default = NULL)
	UnicodeString o_fnam)		//o̓t@C	(default = EmptyStr)
{
	bool ok = false;
	try {
		if (!file_exists(fnam)) Abort();

		std::unique_ptr<TFileStream> fs(new TFileStream(fnam, fmOpenRead | fmShareDenyNone));

		BYTE xbuf[4];
		if (fs->Read(xbuf, 4)!=4) Abort();
		if (xbuf[0]!='f' || xbuf[1]!='L' || xbuf[2]!='a' || xbuf[3]!='C') Abort();

		for (;;) {
			if (fs->Read(xbuf, 1)!=1) Abort();
			bool last_blk = ((xbuf[0]&0x80)!=0);

			int dlen  = fsRead_int3(fs.get(), true);
			int nxt_p = fs->Seek(0, soFromCurrent) + dlen;

			if (xbuf[0]==6) {	//PICTURE
				fs->Seek(4, soFromCurrent);
				//MIME^Cv
				int len = fsRead_int4(fs.get(), true);
				std::unique_ptr<char[]> sbuf(new char[len + 1]);
				if (fs->Read(sbuf.get(), len)!=len) Abort();
				sbuf[len] = 0x00;
				UnicodeString img_typ = sbuf.get();
				//spXLbv
				len = fsRead_int4(fs.get(), true);
				fs->Seek((int)(len + 16), soFromCurrent);

				//C[W
				int size = fsRead_int4(fs.get(), true);
				std::unique_ptr<TMemoryStream> ms(new TMemoryStream());
				if (ms->CopyFrom(fs.get(), size)<size) Abort();
				ms->Seek(0, soFromBeginning);

				if (contained_wd_i(_T("image/jpeg|jpg"), img_typ)) {
					if (bmpimg) {
						if (!WIC_get_from_memory(ms.get(), bmpimg, GUID_ContainerFormatJpeg)) Abort();
						ok = !bmpimg->Empty;
					}
					else if (!o_fnam.IsEmpty()) {
						o_fnam = ChangeFileExt(o_fnam, ".jpg");
						ms->SaveToFile(o_fnam);
						ok = true;
					}
				}
				else if (contained_wd_i(_T("image/png|png"), img_typ)) {
					if (bmpimg) {
						if (!WIC_get_from_memory(ms.get(), bmpimg, GUID_ContainerFormatPng)) Abort();
						ok = !bmpimg->Empty;
					}
					else if (!o_fnam.IsEmpty()) {
						o_fnam = ChangeFileExt(o_fnam, ".png");
						ms->SaveToFile(o_fnam);
						ok = true;
					}
				}
				break;
			}

			if (last_blk) break;

			fs->Seek(nxt_p, soFromBeginning);
		}
	}
	catch (...) {
		ok = false;
	}

	return ok;
}
//---------------------------------------------------------------------------
